=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/MouseHandler.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/MouseHandler.java	2022-02-18 17:35:06 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/MouseHandler.java	2022-03-09 23:18:39 +0000
@@ -33,6 +33,15 @@
 ** 021 AL2 20220126 Don't allow selectable widgets suppress menu button (editors, frames etc.).
 **     VVT 20220128 Missing @Override annotation added, import section cleaned.
 **     VVT 20220218 Javadocs fixes.
+**     VVT 20220222 Method findMouseSource(MouseEvent) pulled up from SwingMouseHandler to make it accessible
+**                  also from WebMouseHandler.
+**     VVT 20220306 1) Method findMouseSource(MouseEvent) pulled up from SwingMouseHandler to make it accessible
+**                  also from WebMouseHandler.  2) Methods processWidgetActions,
+**                  handleMouseEventIfMovable, handleMouseEventIfSelectable inlined 3) Method
+**                  applyMouseEvent(Object mouseAdapter, MouseEvent evt) now accepts all suitably types of
+**                  mouse handlers as the first argument.  4) Method canProcessMouse declared static 5)
+**                  Field mousePressedSourceID added to local context to track the last mouse pressed
+**                  widget.
 */
 
 /*
@@ -102,6 +111,8 @@
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.event.*;
+import com.goldencode.p2j.ui.client.gui.*;
 import com.goldencode.p2j.ui.client.widget.*;
 
 /**
@@ -192,6 +203,15 @@
    }
    
    /**
+    * Set dragging mode ON.
+    * 
+    */
+   public static void startDragMode()
+   {
+      local.get().dragMode = true;
+   }
+   
+   /**
     * Deregister the specified widget for mouse events.
     * 
     * @param    wid
@@ -286,6 +306,45 @@
    }
    
    /**
+    * Apply the specified mouse event to the specified source.
+    * 
+    * @param    mouseAdapter
+    *           The mouse event adapter.
+    * @param    evt
+    *           The mouse event.
+    */
+   private static void applyMouseEvent(Object mouseAdapter, MouseEvent evt)
+   {
+      switch (evt.getID())
+      {
+         case MouseEvent.MOUSE_CLICKED:
+            ((MouseListener)mouseAdapter).mouseClicked(evt);
+            break;
+         case MouseEvent.MOUSE_PRESSED:
+            ((MouseListener)mouseAdapter).mousePressed(evt);
+            break;
+         case MouseEvent.MOUSE_RELEASED:
+            ((MouseListener)mouseAdapter).mouseReleased(evt);
+            break;
+         case MouseEvent.MOUSE_ENTERED:
+            ((MouseListener)mouseAdapter).mouseEntered(evt);
+            break;
+         case MouseEvent.MOUSE_EXITED:
+            ((MouseListener)mouseAdapter).mouseExited(evt);
+            break;
+         case MouseEvent.MOUSE_DRAGGED:
+            ((MouseMotionListener)mouseAdapter).mouseDragged(evt);
+            break;
+         case MouseEvent.MOUSE_MOVED:
+            ((MouseMotionListener)mouseAdapter).mouseMoved(evt);
+            break;
+         case MouseEvent.MOUSE_WHEEL:
+            ((MouseWheelListener)mouseAdapter).mouseWheelMoved((MouseWheelEvent) evt);
+            break;
+      }
+   }
+
+   /**
     * Handle the specified event, in the context of the specified widget.
     * 
     * @param    sourceID
@@ -293,28 +352,129 @@
     * @param    evt
     *           The mouse event.
     */
-   public static void handleMouseEvent(int sourceID, final MouseEvent evt)
+   public static void handleMouseEvent(int sourceID, MouseEvent evt)
    {
-      @SuppressWarnings("unchecked")
-      Widget<GuiOutputManager> source = 
-         (Widget<GuiOutputManager>) OutputManager.resolveWidget(sourceID);
+      Widget<GuiOutputManager> source = (Widget<GuiOutputManager>) OutputManager
+               .resolveWidget(sourceID);
+    
+      WorkArea wa = local.get();
+      Widget<GuiOutputManager> sourceForActions = source;
+      
+      int mousePressedSourceID = wa.mousePressedSourceID;
+
+      switch (evt.getID())
+      {
+         case MouseEvent.MOUSE_DRAGGED:
+            sourceID = mousePressedSourceID;
+            break;
+            
+         case MouseEvent.MOUSE_RELEASED:
+
+            if (mousePressedSourceID != sourceID)
+            {
+               Widget<GuiOutputManager> mousePressedSource = (Widget<GuiOutputManager>) OutputManager
+                        .resolveWidget(mousePressedSourceID);
+               
+               if (mousePressedSource != null)
+               {
+                  if (wa.dragMode)
+                  {
+                     source = mousePressedSource;
+                  }
+                  
+                  if (mousePressedSource.isDirectManipulable())
+                  {
+                     sourceForActions = mousePressedSource;
+                  }
+               }
+            }
+            
+            wa.mousePressedSourceID = 0;
+            wa.dragMode = false;
+            
+            break;
+
+         case MouseEvent.MOUSE_PRESSED:            
+            wa.mousePressedSourceID = sourceID;
+      }
       
       if (source == null)
       {
+         // FIXME: use logging instead of just printing
          System.err.println("Received mouse event for zombie source " + sourceID + ": " +
                             evt.toString());
          return;
       }
       
-      // handle mouse events for selectable widgets.
-      if (source.isDirectManipulable())
+      // Handle direct manipulation actions
+      if (sourceForActions.isDirectManipulable())
       {
-         boolean consume = false;
-         consume = handleMouseEventIfSelectable(source, evt) || consume;
-         consume = handleMouseEventIfMovable(source, evt) || consume;
-         
+         // 1. Handle direct manipulation for selectable widgets.
+         
+         WidgetConfig config = sourceForActions.config();
+         boolean consumeAndExit = false;
+         
+         // Call mouse clicked if left button is clicked.
+         if (config != null && config.selectable && evt.getButton() != sourceForActions.getMenuMouse())
+         {         
+            if (isMouseClickEvent(evt))
+            {
+               // select / deselect
+               if (evt.getID() == MouseEvent.MOUSE_CLICKED)
+               {
+                  performAction(config.id, evt, (action1) -> {
+                     action1.mouseClicked(evt);
+                  });
+               }
+               evt.consume();
+               consumeAndExit = true;
+            }
+         }
+         
+         // 2. Handle direct manipulation for movable widgets.
+         if (config instanceof BaseConfig)
+         {
+            BaseConfig baseConfig = (BaseConfig) config;
+
+            // for movable widgets handle only drag events
+            if (baseConfig != null && baseConfig.movable && evt.getButton() != sourceForActions.getMenuMouse())
+            {
+               Consumer<MouseDirectManipulation> consumer = null;
+               switch (evt.getID())
+               {
+                  case MouseEvent.MOUSE_PRESSED:
+                  {
+                     consumer = (action) -> {
+                        action.mousePressed(evt);
+                     };
+                     break;
+                  }
+                  case MouseEvent.MOUSE_DRAGGED:
+                  {
+                     consumer = (action) -> {
+                        action.mouseDragged(evt);
+                     };
+                     break;
+                  }
+                  case MouseEvent.MOUSE_RELEASED:
+                  {
+                     consumer = (action) -> {
+                        action.mouseReleased(evt);
+                     };
+                     break;
+                  }
+               }
+               
+               if (consumer != null)
+               {
+                  performAction(baseConfig.id, evt, consumer);
+                  consumeAndExit = true;
+               }
+            }
+         }
+
          // Suppress any default behavior on the widget
-         if (consume)
+         if (consumeAndExit)
          {
             evt.consume();
             return;
@@ -322,110 +482,63 @@
       }
       
       applyMouseEvent(source, evt);
+
+      // Process actions
       
       // at this point the source may be destroyed (for example window closed on button click),
       // do not process the event further in this case
       // TODO: this condition is fragile, find a better way to detect this condition
-      if (!(source instanceof TopLevelWindow) && source.ancestor() == null)
+      if (!(sourceForActions instanceof TopLevelWindow)
+               && sourceForActions.ancestor() == null)
       {
          return;
       }
 
-      processWidgetActions(sourceID, evt);
-   }
-   
-   /**
-    * Handle mouse events for movable widgets. 
-    * If the widgets support mouse direct manipulation, call mouse dragged if left button is dragged.
-    * 
-    * @param source  Widget
-    * @param evt     Mouse event
-    * 
-    * @return <code>true</code> iv event has been consumed <code>false</code> if not.
-    */
-   private static boolean handleMouseEventIfMovable(Widget<GuiOutputManager> source, final MouseEvent evt)
-   {
-      WidgetConfig cfg = source.config();
-      if (!(cfg instanceof BaseConfig))
-      {
-         return false;
-      }
-      BaseConfig config = (BaseConfig) cfg;
-      // return code that can differs from evt.isConsumed() result
-      boolean resConsumed = false;
+      List<MouseWidgetAction> actions = wa.actions.get(sourceForActions.getId().asInt());
       
-      // for movable widgets handle only drag events
-      if (config != null && config.movable && evt.getButton() != source.getMenuMouse())
-      {         
-         Consumer<MouseDirectManipulation> consumer = null;
+      if (actions == null)
+      {
+         return;
+      }
+
+      for (MouseWidgetAction action : actions)
+      {
+         applyMouseEvent(action, evt);
          switch (evt.getID())
          {
+            case MouseEvent.MOUSE_CLICKED:
+               action.mouseClicked(evt);
+               break;
+
             case MouseEvent.MOUSE_PRESSED:
-            {
-               consumer = (action) -> {
-                  action.mousePressed(evt);
-               };
-               break;
-            }
+               action.mousePressed(evt);
+               break;
+
+            case MouseEvent.MOUSE_RELEASED:
+               action.mouseReleased(evt);
+               break;
+
+            case MouseEvent.MOUSE_ENTERED:
+               action.mouseEntered(evt);
+               break;
+
+            case MouseEvent.MOUSE_EXITED:
+               action.mouseExited(evt);
+               break;
+
             case MouseEvent.MOUSE_DRAGGED:
-            {
-               consumer = (action) -> {
-                  action.mouseDragged(evt);
-               };
-               break;
-            }
-            case MouseEvent.MOUSE_RELEASED:
-            {
-               consumer = (action) -> {
-                  action.mouseReleased(evt);
-               };
-               break;
-            }
-         }
-         if (consumer != null)
-         {
-            performAction(config.id, evt, consumer);
-            evt.consume();
-            resConsumed = true;
-         }
-      }
-      
-      return resConsumed;
-   }
-   
-   /**
-    * Handle mouse events for selectable widgets. 
-    * If the widgets support mouse direct manipulation call mouse clicked if left button is clicked.
-    * 
-    * @param source  Widget
-    * @param evt     Mouse event
-    * 
-    * @return <code>true</code> iv event has been consumed <code>false</code> if not.
-    */
-   private static boolean handleMouseEventIfSelectable(Widget<GuiOutputManager> source, final MouseEvent evt)
-   {
-      WidgetConfig config = source.config();
-      // return code that can differs from evt.isConsumed() result
-      boolean resConsumed = false;
-      
-      // for selectable widgets handle only mouse clicked events
-      if (config != null && config.selectable && evt.getButton() != source.getMenuMouse())
-      {         
-         if (isMouseClickEvent(evt))
-         {
-            // select / deselect
-            if (evt.getID() == MouseEvent.MOUSE_CLICKED)
-            {
-               performAction(config.id, evt, (action) -> {
-                  action.mouseClicked(evt);
-               });
-            }
-            evt.consume();
-            resConsumed = true;
-         }
-      }
-      
-      return resConsumed;
+               action.mouseDragged(evt);
+               break;
+
+            case MouseEvent.MOUSE_MOVED:
+               action.mouseMoved(evt);
+               break;
+
+            case MouseEvent.MOUSE_WHEEL:
+               action.mouseWheelMoved((MouseWheelEvent) evt);
+               break;
+         }
+      }
    }
    
    /**
@@ -439,16 +552,16 @@
     *          The callback which should be fired.
     */
    private static void performAction(WidgetId id, 
-                                     final MouseEvent evt, 
+                                     MouseEvent evt, 
                                      Consumer<MouseDirectManipulation> mouseAction)
    {
       WorkArea wa = local.get();         
       // get the list of the actions for this widget
-      List<MouseWidgetAction> handlers = wa.actions.get(id.asInt());
-      if (handlers != null)
+      List<MouseWidgetAction> actions = wa.actions.get(id.asInt());
+      if (actions != null)
       {
          // walk through handlers
-         Iterator<MouseWidgetAction> iterAction = handlers.iterator();
+         Iterator<MouseWidgetAction> iterAction = actions.iterator();
          while (iterAction.hasNext())
          {
             MouseWidgetAction action = iterAction.next(); 
@@ -471,7 +584,7 @@
     * 
     * @return <code>true</code> if is a mouse click <code>false</code> if not.
     */
-   private static boolean isMouseClickEvent(final MouseEvent evt)
+   private static boolean isMouseClickEvent(MouseEvent evt)
    {
       int id = evt.getID();
       return id == MouseEvent.MOUSE_CLICKED || id == MouseEvent.MOUSE_PRESSED
@@ -505,101 +618,6 @@
    }
 
    /**
-    * Apply the specified mouse event to the specified source.
-    * 
-    * @param    mouseSource
-    *           The mouse source.
-    * @param    evt
-    *           The mouse event.
-    */
-   protected static void applyMouseEvent(Widget<GuiOutputManager> mouseSource, MouseEvent evt)
-   {
-      switch (evt.getID())
-      {
-         case MouseEvent.MOUSE_CLICKED:
-            mouseSource.mouseClicked(evt);
-            break;
-         case MouseEvent.MOUSE_PRESSED:
-            mouseSource.mousePressed(evt);
-            break;
-         case MouseEvent.MOUSE_RELEASED:
-            mouseSource.mouseReleased(evt);
-            break;
-         case MouseEvent.MOUSE_ENTERED:
-            mouseSource.mouseEntered(evt);
-            break;
-         case MouseEvent.MOUSE_EXITED:
-            mouseSource.mouseExited(evt);
-            break;
-         case MouseEvent.MOUSE_DRAGGED:
-            mouseSource.mouseDragged(evt);
-            break;
-         case MouseEvent.MOUSE_MOVED:
-            mouseSource.mouseMoved(evt);
-            break;
-         case MouseEvent.MOUSE_WHEEL:
-            mouseSource.mouseWheelMoved((MouseWheelEvent) evt);
-            break;
-      }
-   }
-
-   /**
-    * Process the mouse actions registered for the specified source.
-    * 
-    * @param    sourceID
-    *           The source widget ID.
-    * @param    evt
-    *           The mouse event.
-    */
-   protected static void processWidgetActions(int sourceID, MouseEvent evt)
-   {
-      WorkArea wa = local.get();
-
-      List<MouseWidgetAction> actions = wa.actions.get(sourceID);
-      
-      if (actions != null)
-      {
-         for (MouseWidgetAction action : actions)
-         {
-            switch (evt.getID())
-            {
-               case MouseEvent.MOUSE_CLICKED:
-                  action.mouseClicked(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_PRESSED:
-                  action.mousePressed(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_RELEASED:
-                  action.mouseReleased(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_ENTERED:
-                  action.mouseEntered(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_EXITED:
-                  action.mouseExited(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_DRAGGED:
-                  action.mouseDragged(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_MOVED:
-                  action.mouseMoved(evt);
-                  break;
-               
-               case MouseEvent.MOUSE_WHEEL:
-                  action.mouseWheelMoved((MouseWheelEvent) evt);
-                  break;
-            }
-         }
-      }
-   }
-   
-   /**
     * Set the window on which this mouse handler acts.
     * 
     * @param    ews
@@ -739,11 +757,49 @@
    }
    
    /**
+    * Find the mouse source on which the specified event will act, based on coordinates.
+    * 
+    * @param    e
+    *           The event.
+    *           
+    * @return   The mouse source, as returned by {@link Window#findMouseSource}.
+    */
+   protected final Widget<?> findMouseSource(MouseEvent e)
+   {
+      TopLevelWindow<?> window = (TopLevelWindow<?>) WindowManager.findWindow(ews.getWindowId());
+      if (window == null)
+      {
+         // the window may have been gone when the event was generated
+         // during window destroy
+         return null;
+      }
+      
+      Widget<?> mouseSource = window.findMouseSource(new MouseEvt(e, window));
+   
+      // If mouse source has no ID, find the nearest ancestor with ID 
+      Widget mouseSourceWithID = WidgetRegistry.findAncestor(mouseSource, true, t -> {
+         // TODO: to improve/simplify the mouse pointer is over a widget work around to skip labels
+         return UiUtils.getWidgetId(t) != null && !(LabelGuiImpl.class.equals(t.getClass()));
+      });
+   
+      // If the mouse source is ScrollPaneGuiImpl in EditorGuiImpl, return EditorGuiImpl
+      
+      // TODO: move this widget-specific logic into methods that are implemented in the widget
+      // hierarchy so that we do not have direct references to widget classes in this common code
+      if (mouseSourceWithID instanceof ScrollPaneGuiImpl && mouseSourceWithID.parent() instanceof EditorGuiImpl)
+      {
+         return mouseSourceWithID.parent();
+      }
+   
+      return mouseSourceWithID;
+   }
+
+   /**
     * Determine if mouse events can be processed.
     * 
     * @return   See above.
     */
-   protected static boolean canProcessMouse()
+   protected final static boolean canProcessMouse()
    {
       WorkArea wa = local.get();
       synchronized (wa)
@@ -765,6 +821,13 @@
       
       /** Cache of widget's mouse actions. */
       private Map<Integer, RoaringBitmap> cachedActions = new HashMap<>();
+      
+      /** The source ID of the last mouse press event */ 
+      private int mousePressedSourceID;
+
+      /** The "drag" mode flag */ 
+      private boolean dragMode;
+
    }
    
    /**

